
%% Mouse2BBoard

% totmass = 70.5;
% totgain = 50;
totmass = 128;
totgain = 128;
b(1,:)=[0 0 0 0];
b(2,:)=[1 1 1 1];

aH=figure(1);
res=get(0,'ScreenSize');
clf
set(aH,'Color',[0 0 0]);
set(aH,'ToolBar','No');
set(aH,'MenuBar','No');
set(aH,'Position',[1 1 res(3) res(4)])

c=gca;
set(c,'Color',[0 0 0]);
set(c,'YDir','normal')
% set(c,'XLimMode','manual')
% set(c,'YLimMode','manual')
set(c,'Position',[0 0 1 1]);
xlim([0 1])
ylim([0 1])
hold on

sl1 = line([0.25 0.25],[0 0.25],'Color','b','LineWidth',100);
sl2 = line([0.75 0.75],[0 0.25],'Color','b','LineWidth',100);
sl3 = line([0.25 0.25],[0.5 0.75],'Color','b','LineWidth',100);
sl4 = line([0.75 0.75],[0.5 0.75],'Color','b','LineWidth',100);
line([0 1],[0.5 0.5],'Color','y','LineWidth',5)
line([0.5 0.5],[0 1],'Color','y','LineWidth',5)

set(aH,'KeyPressFcn',@keycall);
set(aH,'KeyReleaseFcn',@keycall2);
global keyPressed;
keyPressed=0;
x = zeros(100000,4);
xin = zeros(100000,4);
t= 1;
sens = [0 0 0 0];
sens_old = [1 1 1 1];
tic
while true
%     figure(1)
    mousepointer = get(0,'PointerLocation');

    bbsens = bb.wm.GetBalanceBoardSensorState()/2/wei_sens;
    
    if keyPressed~=0
        if keyPressed=='1'
            sens(1) = mousepointer(2)/res(4);
        elseif keyPressed=='2'
            sens(2) = mousepointer(2)/res(4);
        elseif keyPressed=='3'
            sens(3) = mousepointer(2)/res(4);        
        elseif keyPressed=='4'
            sens(4) = mousepointer(2)/res(4);
        elseif keyPressed==' '
            sens(1:4) = mousepointer(2)/res(4);
        elseif keyPressed=='d'
            sens([2 4]) = mousepointer(2)/res(4);
        elseif keyPressed=='a'
            sens([1 3]) = mousepointer(2)/res(4);            
        elseif keyPressed=='w'
            sens([3 4]) = mousepointer(2)/res(4);
        elseif keyPressed=='s'
            sens([1 2]) = mousepointer(2)/res(4);
        elseif keyPressed=='b'
            pos = mousepointer./res(3:4);
            sens(1) = ((1-pos(1)) + (1-pos(2)))/2;
            sens(2) = ((pos(1)) + (1-pos(2)))/2;
            sens(3) = ((1-pos(1)) + (pos(2)))/2;
            sens(4) = ((pos(1)) + (pos(2)))/2;
        elseif keyPressed=='q'
            break;
        else
            keyPressed
            keyPressed=0;
        end
    end
    sens = (sens+bbsens)/2;
    set(sl1,'YData',[0 sens(1)/2]);
    set(sl2,'YData',[0 sens(2)/2]);
    set(sl3,'YData',[0.5 sens(3)/2+0.5]);
    set(sl4,'YData',[0.5 sens(4)/2+0.5]);
    
    savedSens(t,:) = sens;
    savedBbsens(t,:) = bbsens;
    
    xin(t,:) = sens;
    write_str = [0 0 1 0 2 0 3 0];
    write_str(2:2:end) = kg2pwm((sens-0.5)*totgain*2+totmass,b);s
    x(t,:) = write_str(2:2:end);
%     if sum(sens~=sens_old)>0
%         idx = (sens~=sens_old);
%         for i=1:length(idx)
%             try
%                 fwrite(s,[idx(i) sens(i)]);
%             catch
%                 disp('Timeout Err...');
%             end
%         end
%         sens_old = sens;
%         pause(0.05);
%     end
    try
        fwrite(s,write_str);
    catch
        disp('Timeout Err...')
    end
    drawnow
    SavedTime(t) = toc;
    t=t+1;
end
close all