/*
   4-Channel Dimmer
   Based on http://www.arduino.cc/en/Tutorial/Dimmer
 */

const int ledPins[] = {3, 5, 6, 9};
boolean overflow;

void setup()
{
  // initialize the serial communication:
  Serial.begin(9600);
  // initialize the ledPin as an output:
  for (int i=0; i<4; i++) {
    pinMode(ledPins[i], OUTPUT);
  }
  overflow = false;
}

void loop() {
  byte brightness;
  byte out_channel;

  // check if data has been sent from the computer:
  if (Serial.available()>1) {
    if (overflow) {
      out_channel = Serial.read();
      overflow =false;
    } else {
      out_channel = Serial.read();
      brightness = Serial.read();
      if (int(out_channel)<4) {
        analogWrite(ledPins[out_channel], brightness);
      } else {
        overflow = true;
      }
    }
    //if ((int(out_channel)==255) && (int(brightness)==255)) {
    //  Serial.flush();
    //}
  }
}
