
s = serial('COM3','BaudRate',9600);
fopen(s)
set(s,'Timeout',0.1);

%%

write_str = [0 0 1 0 2 0 3 0];

for i=1:1000
    write_str(2:2:end) = floor(rand(1,4)*255);
    fwrite(s,write_str);
    pause(0.01);
end

%%
% write_str(2:2:end) = 128;
% write_str(2:2:end) = 0;
cout = 128;
write_str(2:2:end) = kg2pwm([cout cout cout cout],b);
% write_str(2:2:end) = kg2pwm([128 128 0 0],b);
% write_str(2:2:end) = 0;
fwrite(s,write_str);

%%
write_str(2:2:end) = 0;
fwrite(s,write_str);
%%
% addpath('C:\Documents and Settings\koerdingLab\My Documents\MATLAB\ian\WiiLAB_Matlab\WiimoteFunctions')
addpath('C:\Documents and Settings\klab\My Documents\MATLAB\ian\WiiLAB_Matlab\WiimoteFunctions');
bb = Wiimote();
bb.Connect();

%%

% pause(2)
val=[]; x=[];
sampvec = 0:2:255;
for chan=1:4
    for i=1:length(sampvec)
        write_str = [0 0 1 0 2 0 3 0];
        write_str(2*chan) = sampvec(i);
        fwrite(s,write_str);
        pause(0.1);
        x((chan-1)*length(sampvec)+i,:) = write_str(2:2:end);
        val((chan-1)*length(sampvec)+i,:) = bb.wm.GetBalanceBoardSensorState();
        plot(val)
        drawnow
    end
end

%%
xse=[]; yse=[];
for i=1:500
    cout = (sin(2*pi*i/100)*40+80);
    write_str = [0 0 1 0 2 0 3 0];
    write_str(2:2:end) = kg2pwm([cout cout cout cout],b);
    fwrite(s,write_str);
    pause(0.1)
    xse(i) = cout;
    yse(i,:) = bb.wm.GetBalanceBoardSensorState();
    plot(1:i,xse','r',1:i,yse','b')
end

%%

sensidx = 3;
x = linspace(-1,1,256);
for i=1:length(x)
    inp = [0 0 0 0];
    inp(sensidx)=x(i);
    tmp = kg2pwm(inp*totgain*2+totmass,b);
    yt(i) = x(i)*totgain*2+totmass;
    y(i) = tmp(sensidx);
end
figure(2)
plot(x,y,x,yt)